]> git.pld-linux.org Git - packages/dhcp.git/blobdiff - dhcp.init
- check networking very early
[packages/dhcp.git] / dhcp.init
index a96dd446fc9f5a217f115f7941d77d21e731488f..476cb93d410cea2e43db2afd0a4c48a818bb3bc0 100644 (file)
--- a/dhcp.init
+++ b/dhcp.init
 # Get network config
 . /etc/sysconfig/network
 
+# Check that networking is up.
+if ! is_yes "${IPV4_NETWORKING}"; then
+       exit 0
+fi
+
 # Get service config
 [ -f /etc/sysconfig/dhcpd ] && . /etc/sysconfig/dhcpd
 
-# Check that networking is up.
-if is_yes "${NETWORKING}"; then
-       if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
-               msg_network_down DHCPD
-               exit 1
-       fi
-else
-       exit 0
+if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
+       msg_network_down "DHCP Server"
+       exit 1
 fi
 
-checkconfig() {
-       show "Checking %s configuration" DHCPD
-       out=`/usr/sbin/dhcpd -t 2>&1`; rc=$?
-       if [ $rc -gt 0 ]; then
-               fail
-               echo >&2 "$out"
+check_device_up()
+{
+       local DEVICE=$1
+       if LC_ALL=C ip addr show dev $DEVICE | grep -q inet; then
+               return 0
        else
-               ok
+               return 1
        fi
+}
+
+# configtest itself
+configtest() {
+       local rc=0
+       /sbin/dhcpd -4 -q -t -T || rc=$?
+
+       # check if interfaces specified exist and have addresses
+       for i in $DHCPD_INTERFACES; do
+               if ! check_device_up $i; then
+                       echo >&2 "Device '$i' does not exist or has no address configured"
+                       rc=1
+               fi
+       done
+
        return $rc
 }
 
+# wrapper for configtest
+checkconfig=-1
+checkconfig() {
+       local details=${1:-0}
+
+       # run checkconfig only once
+       if [ "$checkconfig" != -1 ]; then
+               return $checkconfig
+       fi
+
+       if [ $details = 1 ]; then
+               # run config test and display report (status action)
+               show "Checking %s configuration" "DHCP Server"; busy
+               local out
+               out=$(configtest 2>&1)
+               checkconfig=$?
+               if [ $checkconfig = 0 ]; then
+                       ok
+               else
+                       fail
+               fi
+               [ "$out" ] && echo >&2 "$out"
+               RETVAL=$checkconfig
+       else
+               # run config test and abort with nice message if failed
+               # (for actions checking status before action).
+               configtest >/dev/null 2>&1
+               checkconfig=$?
+               if [ $checkconfig != 0 ]; then
+                       show "Checking %s configuration" "DHCP Server"; fail
+                       nls 'Configuration test failed. See details with %s "checkconfig"' $0
+                       exit $checkconfig
+               fi
+       fi
+}
+
 start() {
        # Check if the service is already running?
-       if [ ! -f /var/lock/subsys/dhcpd ]; then
-               msg_starting "DHCP Server"
-               daemon dhcpd $DHCPD_INTERFACES
-               RETVAL=$?
-               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/dhcpd
-       else
-               msg_already_running DHCPD
+       if [ -f /var/lock/subsys/dhcpd ]; then
+               msg_already_running "DHCP Server"
+               return
        fi
+
+       checkconfig
+       msg_starting "DHCP Server"
+       daemon /sbin/dhcpd -4 -q $DHCPD_INTERFACES
+       RETVAL=$?
+       [ $RETVAL -eq 0 ] && touch /var/lock/subsys/dhcpd
 }
 
 stop() {
-       if [ -f /var/lock/subsys/dhcpd ]; then
-               msg_stopping "DHCP Server"
-               killproc dhcpd
-               rm -f /var/run/dhcpd.pid /var/lock/subsys/dhcpd >/dev/null 2>&1
-       else
-               msg_not_running DHCPD
+       if [ ! -f /var/lock/subsys/dhcpd ]; then
+               msg_not_running "DHCP Server"
+               return
+       fi
+
+       msg_stopping "DHCP Server"
+       killproc --pidfile /var/run/dhcpd.pid dhcpd
+       rm -f /var/run/dhcpd.pid /var/lock/subsys/dhcpd >/dev/null 2>&1
+}
+
+condrestart() {
+       if [ ! -f /var/lock/subsys/dhcpd ]; then
+               msg_not_running "DHCP Server"
+               RETVAL=$1
+               return
        fi
+
+       checkconfig
+       stop
+       start
 }
 
 RETVAL=0
 # See how we were called.
 case "$1" in
   start)
-       checkconfig || exit 1
        start
        ;;
   stop)
        stop
        ;;
   restart)
-       checkconfig || exit 1
+       checkconfig
        stop
        start
        ;;
-  checkconfig)
-       checkconfig
+  try-restart)
+       condrestart 0
+       ;;
+  force-reload)
+       condrestart 7
+       ;;
+  checkconfig|configtest)
+       checkconfig 1
        ;;
   status)
-       status dhcpd
+       status --pidfile /var/run/dhcpd.pid dhcpd
        exit $?
        ;;
   *)
-       msg_usage "$0 {start|stop|restart|checkconfig|status}"
+       msg_usage "$0 {start|stop|restart|try-restart|force-reload|checkconfig|status}"
        exit 3
 esac
 
This page took 0.080437 seconds and 4 git commands to generate.